<template>
  <b-tab title-link-class="custom-tabs">
    <template #title>
      <b-icon icon="table"></b-icon> Attributs
    </template>
    <h3 class="line-header">Attributs</h3>
    <b-alert v-if="errorTxt !== null" show variant="warning" dismissible>{{errorTxt}}</b-alert>
     <FormTextInput v-if="
        layer.type == 'VectorTile'" v-bind:label="'Identifiant'"
              :tooltip="'Attribut identifiant des objets'"
              v-model="layer.idProperty"/>
    <button
      class="btn btn-outline-secondary mb-2 btn-sm"
      v-if="
        layer.type == 'Vector' &&
        layer.editable &&
        contextService.isEditionActive
      "
      @click="addAttribute()"
      title="Ajouter un attribut"
    >
      <i class="fas fa-plus"></i>Ajouter un attribut
    </button>

    <div class="resultLayer">
      <table class="table table-bordered table-hover">
        <thead>
          <tr>
            <th scope="col" class="text-center">
              <input type="checkbox" v-model="selectAll" @click="selectAll()" />
              <i
                class="fas fa-info-circle"
                tooltip
                data-placement="bottom"
                data-html="true"
                data-delay='{"show":50, "hide":1000}'
                title="Cette case determine si l'attribut doit être
                     affiché dans la fiche d'information des objets"
              ></i>
            </th>
            <th scope="col">Nom</th>
            <th scope="col">
              Label
              <i
                class="fas fa-info-circle"
                tooltip
                data-placement="bottom"
                data-html="true"
                data-delay='{"show":50, "hide":1000}'
                title="Modifiez cette valeur pour affiché un label
                           différent du nom de l'attribut dans la fiche d'information"
              ></i>
            </th>
            <th scope="col" class="text-center">Editable</th>
            <th scope="col">Type</th>
          </tr>
        </thead>

        <tbody>
          <tr v-for="(field, index) of layer.layerProperties" :key="index">
            <td width="90" class="text-center">
              <input
                type="checkbox"
                v-model="field.display"
                @click="selectField()"
                style="vertical-align: middle"
              />
            </td>
            <td v-if="!isAttributeEditable(field)">{{ field.name }}</td>
            <td v-if="isAttributeEditable(field)">
              <input type="text" v-model="field.name" class="w-100" />
            </td>
            <td><input type="text" v-model="field.label" class="w-100" /></td>
            <td width="90" class="text-center">
              <input
                type="checkbox"
                v-model="field.editable"
                style="vertical-align: middle"
              />
            </td>
            <td v-if="!isAttributeEditable(field)">
              {{ getFieldType(field.type) }}
            </td>
            <td v-if="isAttributeEditable(field)">
              <b-form-select
                v-model="field.type"
                :options="attributeTypes"
                text-field="label"
                value-field="value"
              ></b-form-select>
              <!-- <ng-select [items]="attributeTypes" bindLabel="label"
                        bindValue="value" name="geomtype"
                          v-model="field.type" [selectableGroup]="true" [clearable]="false">
                        </ng-select> -->
            </td>
          </tr>
        </tbody>
      </table>
    </div>
  </b-tab>
</template>

<script lang="ts">
/* eslint-disable no-param-reassign */
/* eslint-disable class-methods-use-this */
/* eslint-disable @typescript-eslint/explicit-module-boundary-types */
import FormTextInput from '@/components/shared/FormTextInput.vue';
import CapabilitiesParser from '@/models/CapabilitiesParser';
import LayerAttribute from '@/models/map-context/LayerAttribute';
import LayerConfig from '@/models/map-context/LayerConfig';
import Component from 'vue-class-component';
import BaseComponent from '../../BaseComponent';

@Component({
  props: {
    layer: LayerConfig,
  },
  components: {
    FormTextInput,
  },
})
export default class SingleLayerAttributeInfos extends BaseComponent {
  layer!: LayerConfig;

  errorTxt: string | null = null;

  selectAll = false;

  guessMode = false;

  public attributeTypes = [{ value: 'xsd:int', label: 'Entier' },
    { value: 'xsd:string', label: 'Texte' },
    { value: 'xsd:number', label: 'Nombre' },
    { value: 'xsd:boolean', label: 'Booléen' },
    { value: 'xsd:double', label: 'Double' },
  ]

  mounted() {
    if (this.layer.layerProperties.length === 0 && this.layer.isVector()) {
      // No properties, try to guess from datas
      this.guessMode = true;
      const features = this.layer.getLayerSource().getFeatures();
      if (features && features.length > 0) {
        console.log(features[0]);
        features[0].getKeys().forEach((element: any) => {
          this.layer.layerProperties.push(new LayerAttribute({
            name: element,
            type: 'xsd:string',
            editable: true,
            display: true,
          }));
        });
      }
    }
  }

  isAttributeEditable() {
    return (this.layer.editable || this.guessMode) && this.contextService.isEditionActive;
  }

  getFieldType(value: string) {
    if (value.indexOf('xsd:') >= 0) {
      return value.split(':')[1];
    }
    return value;
  }

  addAttribute() {
    this.layer.layerProperties.push(new LayerAttribute({
      name: `nouveau_${this.layer.layerProperties.length}`,
      type: 'xsd:string',
      editable: true,
      display: true,
    }));
  }
}
</script>

<style scoped lang="less">
</style>
